<template>
  <div id="product-info-page">
    <EditProductDetails
      :product="product"
      :items="items"
      @cancel-edit-product-details-event="cancelEditProductDetails"
      @save-new-details-event="saveNewProduct"
    />
    <v-btn
      depressed
      small
      color="green"
      class="go-to-pannel-button"
      v-show="this.product.state === 'Confirmado'"
      @click="goToAdminPanel()"
    >Volver Al Pannel</v-btn>
  </div>
</template>

<script>
import EditProductDetails from './EditProductDetails.vue'

import API from '@/API.js'
export default {
  name: 'EditProductInfoPage',
  components: {
    EditProductDetails
  },
  props: {
    // idActualUser: String,
    // role: String
  },

  data() {
    return {
      actualUserOfThePage: this.$route.params.idActualUser,

      idSearched: null,
      categories: null,
      hasShow: true,
      hasEdit: false,
      // role: "normal",
      // idActualUser: 1,

      actualUserRole: '',
      ifEditProduct: false,
      product: {},
      items: [],
      dateCreate: new Date().toLocaleString()
    }
  },

  async mounted() {
    if (this.actualUserOfThePage === undefined) {
      this.actualUserOfThePage = 'visitor'
    } else {
      this.actualUserRole = await API.getIdActualUser(this.actualUserOfThePage)
    }

    this.idSearched = this.$route.params.idproduct
    await this.putProductDetailsEnData()
    await this.putCategoryDetailsEnData()
    this.items = this.categories.map(sweetItem => {
      return sweetItem['categoryName']
    })
  },

  methods: {
    cancelEditProductDetails() {
      let id_product = this.idSearched
      this.$router.push(
        '/product-detail/' + this.actualUserOfThePage + '/' + id_product
      )
    },

    goToUserPanelPage() {
      let idActualUser = this.actualUserOfThePage
      this.$router.push('/UserPanelControlPage/' + idActualUser)
    },

    async SaveChangedDetails() {
      await this.saveNewProduct()
      await this.putProductDetailsEnData()
      this.ifEditProduct = false
    },

    setImage: function(output) {
      this.localproduct.hasImage = true
      this.localproduct.image = output
    },

    async putCategoryDetailsEnData() {
      this.categories = await API.loadCategories()
    },

    async putProductDetailsEnData() {
      let idSearched = this.idSearched
      this.product = await API.loadProductDetails(idSearched)
    },

    monitoringLocalPhoto(localProduct) {
      if (localProduct.image === undefined) {
        localProduct.image = this.product.urlphoto
      } else {
        localProduct.image = localProduct.image.dataUrl
      }
    },

    async saveNewProduct(localProduct) {
      this.monitoringLocalPhoto(localProduct)
      let idSearched = this.idSearched
      await API.uploadUpdatedProduct(idSearched, localProduct)
      this.putProductDetailsEnData()
      this.cancelEditProductDetails()
    },
    goToAdminPanel() {
      this.$router.push('/DashBoard/')
    }
  }
}
</script>


<style scoped>
#product_details {
  display: flex;
  flex-direction: column;
  justify-content: space-around;
}
.go-to-pannel-button {
  margin-top: 50%;
}
</style>
